/** 
 * MooDS Encoder/Decoder for Flash.
 * Encoding version: 1200
 * @author Generated by MooDS Generator v2.1.0 - 2006 CNAM, INT, Filao 
 */
//#include parameters.h
////#define LOGGING_HTTP
//#endinclude

package org.mega.gasp.bluetooth.games.demonstrator;

import java.util.Hashtable;
import java.io.DataOutputStream;
import java.io.DataInputStream;

import org.mega.gasp.bluetooth.games.demonstrator.client.NetworkCom;
import org.mega.gasp.bluetooth.miniplatform.Utils;
import org.mega.gasp.bluetooth.games.demonstrator.*;

//This class has been generated by MooDS Generator to handle objects
// for binarisation input/output.
public class CustomTypes implements org.mega.gasp.bluetooth.miniplatform.CustomTypes{
	// types
	public final static byte TYPE_NEWPLAYER = 3;
	public final static byte TYPE_UPDATEPLAYER = 4;

	public CustomTypes() {
		Utils.logClient("CustomTypes initialized");
		
	}
	
	// encodeData root method
	public void encodeData(Hashtable h,DataOutputStream dos) throws Exception {
		Utils.logClient("encodeData called");
		dos.writeShort(1200);
		dos.writeShort(h.size());
		int nbSend = h.size();
		for(int i=0; i <nbSend; i++){
			Object o = h.get(""+i);
			if (o instanceof NewPlayer) {
				dos.writeByte(TYPE_NEWPLAYER);
				encodeNewPlayer(dos,((NewPlayer) o));
			}
			if (o instanceof UpdatePlayer) {
				dos.writeByte(TYPE_UPDATEPLAYER);
				encodeUpdatePlayer(dos,((UpdatePlayer) o));
			}
			
		}
	}


	// decodeData rooy method
	public Hashtable decodeData(DataInputStream dis) throws Exception {
		Utils.logClient("decodeData called");
		dis.readShort();
		Hashtable h = new Hashtable();
		short nb = dis.readShort();
		int nbObj = nb;
		while (nb != 0) {
			String key = ""+(nbObj - nb);
			byte type = dis.readByte();
			
			if (type == TYPE_NEWPLAYER) {
				NewPlayer customType = decodeNewPlayer(dis);
				h.put(key,customType);
			}
			if (type == TYPE_UPDATEPLAYER) {
				UpdatePlayer customType = decodeUpdatePlayer(dis);
				h.put(key,customType);
			}
			
			nb--;
		}
		return h;
	}


	// encoding method for each custom type
	private void encodeNewPlayer(DataOutputStream dos,NewPlayer customType) throws Exception {
		dos.writeShort(customType.getId());
		dos.writeInt(customType.getX());
		dos.writeInt(customType.getY());
		dos.writeUTF(customType.getUsername());
	}


	private void encodeUpdatePlayer(DataOutputStream dos,UpdatePlayer customType) throws Exception {
		dos.writeShort(customType.getId());
		dos.writeInt(customType.getX());
		dos.writeInt(customType.getY());
		dos.writeInt(customType.getSpeedX());
		dos.writeInt(customType.getSpeedY());
	}

	// decoding method for each custom type
	public NewPlayer decodeNewPlayer(DataInputStream dis) throws Exception {
		NewPlayer customType = NetworkCom.getSingleton().newNewPlayerMessage();

		customType.setId(dis.readShort());
		customType.setX(dis.readInt());
		customType.setY(dis.readInt());
		customType.setUsername(dis.readUTF());
		return customType;
	}


	public UpdatePlayer decodeUpdatePlayer(DataInputStream dis) throws Exception {
		UpdatePlayer customType = NetworkCom.getSingleton().newUpdatePlayerMessage();

		customType.setId(dis.readShort());
		customType.setX(dis.readInt());
		customType.setY(dis.readInt());
		customType.setSpeedX(dis.readInt());
		customType.setSpeedY(dis.readInt());
		return customType;
	}


}
