/***
 * GASP: a gaming services platform for mobile multiplayer games.
 * MooDS: a communication protocol used in GASP.
 * GASP Demonstrator: a gasp demonstration game.
 *
 * Copyright (C) 2004 CNAM/INT
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contact: gasp-team@objectweb.org
 *
 * Author: Franck Caron, Romain Pellerin
 */
/*
 * Created on 2 december 2005
 *
 * @author CARON Franck - CNAM CEDRIC
 * @author PELLERIN Romain - CNAM CEDRIC
 * 
 * 
 * Research project: CNAM-CEDRIC - INT - Filao
 */
//#include parameters.h
////#define LOGGING_HTTP
//#endinclude
/*
 * Created on 18 juin 2004
 */
package org.mega.gasp.bluetooth.games.demonstrator.client;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

import javax.microedition.lcdui.Choice;
import javax.microedition.lcdui.ChoiceGroup;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.Item;
import javax.microedition.lcdui.List;
import javax.microedition.lcdui.StringItem;
import javax.microedition.lcdui.TextBox;
import javax.microedition.lcdui.TextField;
import javax.microedition.rms.RecordStore;
import javax.microedition.rms.RecordStoreException;
import javax.microedition.rms.RecordStoreFullException;
import javax.microedition.rms.RecordStoreNotOpenException;

import org.mega.gasp.bluetooth.games.demonstrator.ApplicationInstanceInfos;
import org.mega.gasp.bluetooth.games.demonstrator.client.GameCanvas;
import org.mega.gasp.bluetooth.games.demonstrator.client.SimpleGameCanvas;
import org.mega.gasp.bluetooth.miniplatform.GASPClient;
import org.mega.gasp.bluetooth.miniplatform.SubApplicationInstance;
import org.mega.gasp.bluetooth.games.demonstrator.Utils;


/**
 * @author Cybernash, Maxime Wozny ,Alexandre Garc�, Moez Habib Thameur, Franck CARON
 */
public class IHMGasp /*extends GASPClient*/ implements CommandListener,
        Runnable {
	   
    private Command joinCommand = new Command("Join", Command.SCREEN, 1);
    private Command loginCommand = new Command("Login", Command.ITEM, 1);
    private Command createCommand = new Command("Create", Command.ITEM, 1);
    private Command startCommand = new Command("Start", Command.ITEM, 1);
    private Command quitAICommand = new Command("QuitSession", Command.ITEM, 1);
    private Command endCommand = new Command("Pause", Command.ITEM, 1);
    private Command quitCommand = new Command("Quit", Command.EXIT, 1);
    protected Vector otherPlayers;
    private App midlet;
    public SimpleGameCanvas gameCanvas;
    private Display display;
    /** owner actor session ID : identifiant du owner (createur de la partie) dans la partie en cours */
    private int ownerASID;
    private boolean isOwner;
    /** liste des asID des autres joueurs dans la partie en cours */
    public  Vector gameSessionPlayers;
    /** tableau des Applications Instances IDs (identifiants des parties de ce jeu en cours) */
    private int[] currentAIIDList;
    /** true si le joueur entamme une nouvelles partie, false sinon */
    private boolean newGame=true;
    private boolean firstTime;
    /**
     * mode, player is in:
     * 0 -> mainscreen
     * 1 -> lobby chooseScreen
     * 2 -> waitingRoom
     * 3 -> inGame
     * 4 -> waitingRoom avec start
     * 5 -> startRoom
     */
    protected int mode;
    /** Objet de synchronization : utilisation de la variable mode dans diff�rents threads */
    protected Object modifMode = new Object();;
    /** Array of target locations. */
    private Vector appInstances;
    /** User interface list for selection. */
    private List list;
    /** Current command to proccess. */
    private Command currentCommand;
    /** The current command processing thread. */
    private Thread commandThread;
    /** Message area. */
    private TextBox t;
    
    private NetworkCom networkCom;
    
    protected int NumeroJoueur;
	public String pseudoname = "Player";
	public boolean gameInitialized = false;
    
    public IHMGasp(App parent) {
        midlet=parent;
        display=Display.getDisplay(midlet);
        gameSessionPlayers = new Vector();
        networkCom = new NetworkCom(parent);
        networkCom.ihmGasp = this;
        appInstances = new Vector();
        firstTime=true;
        setMode(2);
        otherPlayers=new Vector();
    }
    
    
    public void setMode(int mode){
        this.mode = mode;
    }
    
    public Object getDisplay() {
        return display;
    }
    
    public void startApp() {
        System.err.println("CLIENT START");
        if(firstTime) {
            join();
            currentScreen();
            firstTime = false;
        } else {
            display.setCurrent(t);
        }
    }
    
    /*Perform the current command set by the method commandAction.*/
    public void run() {
        if (currentCommand == joinCommand) {
            synchronized(this.modifMode){
                setMode(2);
                join();
                //pkoi ici pas de currentScreen() ????
            }
        } else if (currentCommand == startCommand) {
            synchronized(this.modifMode){
            	setMode(3);
                startAI();
                if(!this.midlet.isServer())
                    currentScreen();
                
            }
        } else if (currentCommand == quitAICommand) {
            synchronized(this.modifMode){
                setMode(1);
                quitAI();
                currentScreen();
            }
        } else if (currentCommand == quitCommand) {
            quit();
            //pkoi ici pas de currentScreen() ????
        } else if (currentCommand == endCommand) {
            synchronized(this.modifMode){
                setMode(4);
                gameInitialized = false;
                endAI();
                currentScreen();
            }
        } synchronized (this) {
            // signal that another command can be processed
            commandThread = null;
        }
    }
    
    /*Gestion des commandes*/
    
    public void commandAction(Command c, Displayable s){
        synchronized (this) {
            if (commandThread != null) {
                // process only one command at a time
                return;
            }
            currentCommand = c;
            commandThread = new Thread(this);
            commandThread.start();
        }
    }
    
    void setCommands(Displayable d, int commandMode) {
        switch (commandMode){
            case 0:
                d.addCommand(loginCommand);
                break;
            case 1: // Lobby screen with no game session
                d.addCommand(createCommand);
                d.addCommand(quitCommand);
                break;
            case 2: // Lobby screen with game session
                d.addCommand(createCommand);
                d.addCommand(joinCommand);
                d.addCommand(quitCommand);
                break;
            case 3: // Waiting room
                d.addCommand(quitAICommand);
                d.addCommand(quitCommand);
                break;
            case 5: // Waiting room
                if (networkCom.getASID() == SubApplicationInstance._LOC_ASID) {d.addCommand(startCommand);   System.err.println("_loc_asid oui");}
                
                d.addCommand(quitAICommand);
                d.addCommand(quitCommand);
                break;
            case 6: // Start room
                d.addCommand(startCommand);
                d.addCommand(quitCommand);
                break;
            case 4: // In Game room commands
                if (App.getInstance().isServer()) d.addCommand(endCommand);
                d.addCommand(quitAICommand);
                d.addCommand(quitCommand);
                break;
            default: break;
        }
        d.setCommandListener(this);
    }
    /*Gestion des commande du jeu*/
    /* Le joueur rejoint une partie*/
    private void join() {
        networkCom.join();
    }
    
    protected void startAI() {
        networkCom.startAI();
    }
    
    //	--------------Switching Canvases -----------------------------------
    public void startGame() {
    	try{
    		Utils.logClient("The game starts!");
        	mode = 3;
            
        	/** 
             * initialize game
             */
        	gameCanvas = new SimpleGameCanvas(midlet,this,(int) NetworkCom.minimalRequestDeltaTime);
            gameCanvas.initialize();
            
            /**
             *  start game
             */
    		gameCanvas.newGame();
    		gameCanvas.restart();
    		gameInitialized = true;
        } catch(Exception e){
            Utils.logClient("Unable to start game");
            e.printStackTrace();
        }
    }
    
    /*Met la partie en cours en pause*/
    private void endAI() {
        //this.midlet.gameCanvas.pauseAction();
        networkCom.endAI();
    }
    
    /*Quitte la partie en cours mais reste connect�*/
    private void quitAI() {
        networkCom.quitAI();
        reInit();
        //if(this.midlet.gameCanvas!=null) this.midlet.gameCanvas.quit();
    }
    
    /*Fin de partie, perdue*/
    protected void loose() {
        synchronized(this.modifMode){
            alertScreen("Game Over");
            if (App.getInstance().isServer()) setMode(4);
            else setMode(2);
            newGame=true;
            
            gameCanvas.quit();
            currentScreen();
        }
    }
    
    synchronized void alertScreen(String s) {
        t = new TextBox("Alert", s, s.length(), 0);
        display.setCurrent(t);
        try {
            Thread.sleep(1300);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }
    
    /* Fin de partie, gagn�e*/
    protected void win() {
        synchronized(this.modifMode){
            alertScreen("You win...");
            if (App.getInstance().isServer()) setMode(4);
            else setMode(2);
            newGame=true;
            
            gameCanvas.quit();
            currentScreen();
        }
    }
    
    /*Quitte la partie en cours en se deconnectant*/
    protected void quit() {
        if (mode!= 1){
            // player in waiting room or in game
            networkCom.quitAI();
        }
        networkCom.quit();
        midlet.exitRequested();
        
    }
    
    /*Reinitialisation des variables en fin de partie*/
    public void reInit(){
        networkCom.setASID(0);
        gameSessionPlayers.removeAllElements();
        newGame=true;
    }
    
    public void endGame() {
        // TODO Auto-generated method stub
    }
    
    /*Gestion des evenements*/
    
    /**
     * Lancement de la partie
     * @param actorSessionID du joueur qui a lanc� la partie
     */
    public void onStartEvent(int actorSessionID) {
        synchronized(this.modifMode){
        	alertScreen("The game session owner starts the game!");
            Utils.logClient("onStartEvent called");
            setMode(3);
            currentScreen();
            
        }
    }
    
    public void onMyJoinEvent(int actorSessionID) {
        pseudoname += actorSessionID;
    	Utils.logClientHL("MyJoinEvent:" + actorSessionID);
        NumeroJoueur=actorSessionID-1;
        currentScreen();
    }
    
    /**
     * Mise a jour de la liste des joueurs en waitingroom.
     * Si le bon nombre de joueur est atteind, la owner lance la partie.
     * @param actorSessionID du joueur qui a rejoint la partie
     */
    public void onJoinEvent(int actorSessionID) {
        
        // the first player join the application instance was the owner
        Utils.logClientHL("JoinEvent:" + actorSessionID);
        if (actorSessionID == networkCom.getASID()) return;
        
        int i = gameSessionPlayers.size();
        gameSessionPlayers.insertElementAt(new Integer(actorSessionID),i);
        if (actorSessionID == SubApplicationInstance._LOC_ASID){
            ownerASID = actorSessionID;
            alertScreen("The game session owner joins: aSID>"+actorSessionID);
        } else{
            alertScreen("A new player joins: aSID>"+actorSessionID);
        }
        otherPlayers.insertElementAt(new Integer(actorSessionID-1),i);
        if(actorSessionID == SubApplicationInstance._LOC_ASID && gameSessionPlayers.size()>2) {
            setMode(5);
        }
        setMode(4);
        currentScreen();
    }
    
    
    public void onDataEvent(int actorSessionID, Hashtable datas) {
    	gameCanvas.onDataEvent(actorSessionID,datas);
    }
    //	currentScreen();
    
    
    /**
     * Mise en pause de la partie
     * @param actorSessionID du joueur qui a execut� le end
     */
    public void onEndEvent(int actorSessionID) {
        synchronized(this.modifMode){
            if(this.mode==3){
            	alertScreen("The game session owner has stopped the game! Return to the waiting room.");
                //if (this.midlet.gameCanvas!=null) this.midlet.gameCanvas.pauseAction();
                setMode(2);
                gameInitialized = false;
                currentScreen();
            }
        }
    }
    
    /**
     * Si le owner a quitt� la partie, le joueur quit la partie en cours et retourne dans le lobbyroom
     * sinon quit puis retour dans la waiting room
     * @param actorSessionID du joueur qui a quitt� la partie
     */
    public void onQuitEvent(int actorSessionID) {
        synchronized(this.modifMode){
            if (ownerASID == actorSessionID){
                setMode(1);
                alertScreen("The game session owner has leaved the game, the game session has been distructed.\nReturn to the Lobby choose room.");
                reInit();
                //if(this.midlet.gameCanvas!=null) this.midlet.gameCanvas.quit();
                currentScreen();
            } else{
                setMode(2);
                alertScreen("The player n�"+actorSessionID+" has leaved the game");
                if (App.getInstance().isServer()) networkCom.endAI();
                removePlayer(actorSessionID);
                
                newGame = true;
                //if(this.midlet.gameCanvas!=null) this.midlet.gameCanvas.quit();
                currentScreen();
            }
        }
    }
    
    
    /**
     * Remove the player corresponding to the actorSessionID.
     * @param actorSessionID
     */
    private void removePlayer(int actorSessionID) {
        for(int i=0; i<gameSessionPlayers.size();i++){
            if (((Integer) gameSessionPlayers.elementAt(i)).intValue() == actorSessionID){
                gameSessionPlayers.removeElementAt(i);
            }
        }
    }
    
    
    /*Gestion des ecrans*/
    /**
     * This methods provides to draw the appropriate screen.
     */
    protected void currentScreen() {
        switch (this.mode){
            case 0:
                mainScreen();
                break;
            case 1:
                lobbyScreen();
                break;
            case 2:
                waitingRoomScreen(true);
                break;
            case 4:
                waitingRoomScreen(false);
                break;
            case 5:
                startRoomScreen();
                break;
            case 3:
                gameRoom();
                break;
            default: break;
        }
    }
    
    /**
     * Display the main screen.
     */
    void mainScreen() {
        String s = "Hi, click join to enter the MGP";
        t = new TextBox("GPClientTest", s, s.length(), 0);
        setCommands(t, 0);
        mode=2;
        Utils.logClientHL("mainScreen mode:"+mode);
        
        display.setCurrent(t);
    }
    
    
    
    /**
     * Display the Lobby screen.
     */
    void lobbyScreen() {
        try{
            appInstances = networkCom.getApplicationInstances();
            int  indexMax = appInstances.size();
            currentAIIDList = new int[indexMax];
            if (indexMax == 0){
                String s = "Currently no game sessions to join";
                t = new TextBox("Lobby", s, s.length(), 0);
                setCommands(t, 1);
                t.setCommandListener(this);
                display.setCurrent(t);
            } else{
                int current = -1;
                if (list!=null) current = list.getSelectedIndex();
                list = new List("Lobby", Choice.EXCLUSIVE);
                list.setCommandListener(this);
                for (int i = 0; i < appInstances.size(); i++) {
                    ApplicationInstanceInfos appInfos = (ApplicationInstanceInfos)appInstances.elementAt(i);
                    int aIID = appInfos.getApplicationInstanceID();
                    currentAIIDList[i] = aIID;
                    int nbP = appInfos.getNbPlayers();
                    list.append("ApplicationInstanceID: "+aIID+ " nbPlayers:"+ nbP, null);
                }
                if (current!=-1)
                    if(current<list.size()) list.setSelectedIndex(current,true);
                    else list.setSelectedIndex(list.size()-1,true);
                setCommands(list, 2);
                display.setCurrent(list);
            }
        } catch (Exception e){e.printStackTrace();}
    }
    
    /**
     * Display the Waiting room screen.
     */
    void waitingRoomScreen(boolean type) {
        try{
            list = new List("Waiting Room - Players", Choice.EXCLUSIVE);
            //Nom du joueur du telephone
            list.append("You: aSID>"+networkCom.getASID()+"type>"+NumeroJoueur,null);
            list.setCommandListener(this);
            for (int i = 0; i < gameSessionPlayers.size(); i++) {
                Integer aSIDOf = (Integer)gameSessionPlayers.elementAt(i);
                //Noms des joueurs dans la Waiting Room
                if (aSIDOf.intValue()== ownerASID) list.append("Owner: aSID>"+aSIDOf.intValue(),null);
                else list.append("Player: aSID>"+aSIDOf.intValue(),null);
            }
            if (type) setCommands(list, 3);
            else setCommands(list, 5);
            display.setCurrent(list);
        } catch (Exception e){e.printStackTrace();}
    }
    
    /**
     * Display the start screen.
     */
    void startRoomScreen() {
        try{
            String s = "Vous pouvez lancer la partie";
            t = new TextBox("Start Room", s, s.length(), 0);
            setCommands(t, 6);
            t.setCommandListener(this);
            display.setCurrent(t);
        } catch (Exception e){e.printStackTrace();}
    }
    
    
    /**
     * Display the Waiting room screen.
     */
    void gameRoom() {
        try{
        	NetworkCom.nbPlayers = gameSessionPlayers.size()+1;

        	if(newGame)
                alertScreen("Game starting ...");
            startGame();
            setCommands(gameCanvas, 4);
            gameCanvas.setCommandListener(this);
            display.setCurrent(gameCanvas);
        } catch (Exception e){e.printStackTrace();}
        
    } 
    
    /**
	 * method is used to transmit a message from GameCanvas to NetworkCom
	 */
	public void sendMessage(Object o) {
		networkCom.addMessageToSend(o);
	}


	public Object update() {
		return gameCanvas.cyclicUpdateMessagesToSend();
	}


	public int getMode() {
		return mode;
	}
}
	
    
	
