/***
 * GASP: a gaming services platform for mobile multiplayer games.
 * MooDS: a communication protocol used in GASP.
 * GASP Demonstrator: a gasp demonstration game.
 *
 * Copyright (C) 2004 CNAM/INT
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contact: gasp-team@objectweb.org
 *
 * Author: Franck Caron, Romain Pellerin
 */
/*
 * Created on 2 december 2005
 *
 * @author CARON Franck - CNAM CEDRIC
 * @author PELLERIN Romain - CNAM CEDRIC
 * 
 * 
 * Research project: CNAM-CEDRIC - INT - Filao
 */
package org.mega.gasp.bluetooth.games.demonstrator.server;

//import java.util.Enumeration;

import java.util.Enumeration;
import java.util.Hashtable;

import org.mega.gasp.bluetooth.miniplatform.Event;
import org.mega.gasp.bluetooth.miniplatform.GASPServer;

import java.util.Vector;
import org.mega.gasp.bluetooth.miniplatform.ActorSession;
import org.mega.gasp.bluetooth.games.demonstrator.client.App;

import org.mega.gasp.bluetooth.games.demonstrator.*;
/**
 * @author PELLERIN Romain (CNAM Paris, romain.pellerin@laposte.net)
 * @author DELPIANO Fabien (Pastagames, fabien@pastaga.net)
 * @author KOCIK Fabrice - (Pastagames, fabrice@pastis.org)
 * @author CARON Franck - (CNAM Paris)
 * --
 * JIMM Project 2005
 * (Bouygues Telecom, CNAM Paris, Pastagames)
 */
public class Server extends GASPServer {
	private App app;
	private int maxActor = 0;

	private boolean gameIsStarted = false;

	
	/**
	 * This table allow us to know if a player is in game or not.
	 * players[aSID]=1 if the player is connected, else -1.
	 */

	//private Player[] players;
	private Hashtable playersTable = new Hashtable();
	
	/**
	 * This table allow us to store pings received from players to transmit to other players
	 */
	
	//private Vector[] pings;
	private Hashtable htPlayerPing = new Hashtable();
	
	public Server(org.mega.gasp.bluetooth.games.demonstrator.client.App a) {
		super();
		this.app = a;
		//thread = new Thread(this);
		init();
	}

	/**
	 * Initialization of the fields of the server.
	 */
	private void init() {
	}

	public void start() {
		//cat.debug("Server START running!");
		//thread.start();
	}

	public void end() {
		//cat.debug("Server STOP!");
		//thread.stop();
	}

	/*********************************************************************************/
	/** Listenners : onStartEvent, onEndEvent, onJoinEvent, onQuitEvent, onDataEvent**/
	/*********************************************************************************/

	public void onStartEvent(Event e) {
		//cat.debug("STARTEVENT received by server: aSID>"
		//		+ se.getActorSessionID());
		start();
		gameIsStarted = true;
		//players = new Player[maxActor + 1];
		//pings = new Vector[maxActor + 1];
		
		/*for(int i = 1; i <= maxActor; i++){
			pings[i] = new Vector();
		}*/
	}

	public void onEndEvent(Event ee) {
//		cat.debug("ENDEVENT received by server: aSID>"
//				+ ee.getActorSessionID());
		end();
	}

	public void onJoinEvent(Event je) {
//		cat.debug("JOINEVENT received by server: aSID>"
//				+ je.getActorSessionID() + " username>" + je.getUsername());
		
	}
	
	public void onQuitEvent(Event qe) {
//		cat.debug("QUITEVENT received by server: aSID>"
//				+ qe.getASID());

		// for waiting room only
		if (!gameIsStarted)
			maxActor--;
		
		int aSID = qe.getASID();
		playersTable.remove(""+aSID);
		
		if (gameIsStarted) {
			htPlayerPing.remove(""+aSID);
			//players[aSID] = null;
		}

	}

	public void onDataEvent(Event de) {
		int sender = de.getASID();
		
		Hashtable h = de.getHashtable();
		Enumeration e = h.keys();
		
		Enumeration enume= playersTable.keys();
		while (enume.hasMoreElements()){
			short pid = Short.parseShort((String) enume.nextElement());

			if (pid != sender) {
				//System.out.println("Dest:" + pid + " MessageType:"
				//		+ de.getHashtable().get("0").getClass());
				app.getSAI().sendDataToActorSession(pid, de);
			}
		}
	}

	public void onMyJoinEvent(Event mje) {
		System.out.println("onMyJoinEvent from player "+mje.getASID());
		maxActor++;
		Player p = new Player(mje.getASID());
		playersTable.put(""+mje.getASID(),p);
	}
}
